;************************************************************
;   ⮢  PIC16F84
;************************************************************
OSCCAL	    equ	       05h	   ;

Indf	    equ	       00h	   ;    १ FSR
IndF	    equ	       00h	   ;    १ FSR
Timer	    equ	       01h	   ; TMR0
OptionR	    equ	       01h	   ; Option (RP0=1)
PC	    equ	       02h	   ; 稪 
PCL	    equ	       02h	   ; 稪 
Status	    equ	       03h	   ; Status
Fsr	    equ	       04h	   ;  ᢥ 樨
FSR	    equ	       04h	   ;  ᢥ 樨
PortA	    equ	       05h	   ; Port A
TrisA	    equ	       05h	   ; Tris A - RP0=1
PortB	    equ	       06h	   ; Port B
TrisB	    equ	       06h	   ; Tris B - RP0=1
GPIO	    equ	       06h	   ; equ PortB  16f84
Port	    equ	       06h	   ; Port
EEData	    equ	       08h	   ; EEPROM Data
EECon1	    equ	       08h	   ; EECON1 - RP0=1
EEAdr	    equ	       09h	   ; EEPROM Address
EECon2	    equ	       09h	   ; EECON2 - RP0=1
PClath	    equ	       0Ah	   ;   PC
IntCon	    equ	       0Bh	   ;  뢠
;************************************************************
W	    equ	       0	   ;   
F	    equ	       1	   ;   ॣ
;******************** Flag bits: ****************************
CF	    equ	       0	   ; ७ - Carry
CR	    equ	       0	   ; ७ - Carry
zr	    equ	       2	   ; Zero
ZF	    equ	       2	   ; Zero
RP0	    equ	       5	   ; ࠭
;***************** INTCON Bits *******************************
Gie	    equ	       7    ; ࠧ襭  뢠
xxxx	    equ	       6    ;
Rtie	    equ	       5    ; ࠧ.. Rtcc
Inte	    equ	       4    ; ࠧ..   B0
Rbie	    equ	       3    ; ࠧ..   B4-7
Rtif	    equ	       2    ; 䫠 ९ Rtcc
Intf	    equ	       1    ; 䫠  	 B0
Rbif	    equ	       0    ; 䫠  	 B4-7
;***************** OPTION Bits *******************************
Gpwu	    equ	       7    ; INT ᫥	Sleep
Rpbu	    equ	       6    ; 0-祭 ⨢ 㧮
Rts	    equ	       5    ; RTCC 0=Fosk/4 1- 뢮	p2
Rte	    equ	       4    ; inc RTCC 0- ⥫쭮 ஭
Psa	    equ	       3    ; ⥫:	0  RTCC \ 1  WDT
Ps2	    equ	       2    ; 樥 
Ps1	    equ	       1    ; RTCC  1/2 (000)	 1/256 (111)
Ps0	    equ	       0    ; WDT   1/1 (000)	 1/128 (111)
;************************************************************
W	    equ	       0    ; 	 
F	    equ	       1    ; 	 ॣ
;******************** Status bits ***************************
CR	    equ	       0    ; ७ -	Carry
ZR	    equ	       2    ; Zero
RP0	    equ	       5    ; ࠭
;***********************************************************************
mov	macro	metka1,metka2	   ;  - 뫪	2->1
	movf	metka2,w	   ; ᮢ⨬  Z80
	movwf	metka1		   ;
	endm			   ;  
movtof	macro	metka1		   ;  - 뫪	W->1
	movwf	metka1		   ;
	endm			   ;  
movtow	macro	metka1		   ;  - 뫪	1->W
	movf	metka1,0	   ;
	endm			   ;  
mvi	macro	metka1,constant	   ;  - 뫪	constant->1
	movlw	constant	   ; ᮢ⨬  Z80
	movwf	metka1		   ;
	endm			   ;  
ret	macro			   ;  - 
	return			   ; ᮢ⨬  Z80
	endm			   ;  
jmp	macro	metka		   ;  - 室
	goto	metka		   ; ᮢ⨬  Z80
	endm			   ;  
jnz	macro	metka		   ;  - ᫮ 室
	btfss	Status,2	   ; ᫨ -  = 0
	goto	metka		   ; ᮢ⨬  Z80
	endm			   ;  
jz	macro	metka		   ;  - ᫮ 室
	btfsc	Status,2	   ; ᫨ - = 0
	goto	metka		   ; ᮢ⨬  Z80
	endm			   ;  
rz	macro			   ;  - ᫮ 
	btfsc	Status,2	   ; 	ணࠬ
	return			   ; , ᫨ - = 0
	endm			   ;  
rnz	macro			   ;  - ᫮ 
	btfss	Status,2	   ; 	ணࠬ
	return			   ; , ᫨ -  = 0
	endm			   ;  
cz	macro	metka		   ;  - ᫮ 맮
	btfsc	Status,2	   ; ணࠬ
	call	metka		   ; 맮 , ᫨ - = 0
	endm			   ;  
cnz	macro	metka		   ;
	btfss	Status,2	   ;
	call	metka		   ; 맮 , ᫨ -  = 0
	endm			   ;  
jnc	macro	metka		   ;  - ᫮ 室
	btfss	Status,0	   ; ᫨ - > 0
	goto	metka		   ; ᮢ⨬  Z80
	endm			   ;  
jc	macro	metka		   ;  - ᫮ 室
	btfsc	Status,0	   ; ᫨ - < 0
	goto	metka		   ; ᮢ⨬  Z80
	endm			   ;  
cnc	macro	metka		   ;  - ᫮ 맮
	btfss	Status,0	   ; ணࠬ
	call	metka		   ; ᫨ - > 0
	endm			   ;  
cc	macro	metka		   ;  - ᫮ 맮
	btfsc	Status,0	   ; ணࠬ
	call	metka		   ; ᫨ - < 0
	endm			   ;  
rnc	macro			   ;  - ᫮ 室
	btfss	Status,0	   ; ᫨ - > 0
	return			   ; ᮢ⨬  Z80
	endm			   ;  
rc	macro			   ;  - ᫮ 室
	btfsc	Status,0	   ; ᫨ - < 0
	return			   ; ᮢ⨬  Z80
	endm			   ;  
cmp	macro	metka1,metka2	   ; ࠢ 1  2
	movf	metka2,w	   ;
	subwf	metka1,w	   ; ᮢ⨬  Z80
	endm			   ;  
cpi	macro	metka2,metka1	   ; ࠢ 2  ⠭
	movf	metka2,w	   ;
	sublw	metka1		   ; ᮢ⨬  Z80
	endm			   ;  
;************************************************************

