;************************************************************
;   Filename:		longlgt	.asm			    *
;   First Date:		12 november 2000		    *
;   Last  Date:		11 December  2002		    *
;   File Version:	1.00		   N-3  95	    *
;   Assembler:		mpasm 1.40	   + 5612	    *
;   Author:		Bogdanov Andrew			    *
;*******************************************************************
   LIST	  p=16C554 ; 13-4cp|off=1. 3pwrt|on=1. 2wdt|on=1. 1-0osc|xt
 __CONFIG b'11111110111101'	;
;***********************************************************************
#include  pic_mac.inc	; ᠭ ᮢ  ॣ஢
;******************* Mode1 Bits	*****************************************
b1_stop	  equ	 0	 ;  䫠, ⮯=0 =1
b1_wrStop equ	 1	 ;  䫠 ⠭  ᫥.
b1_direct equ	 2	 ;  ઠ:  - ࠢ
b1_weit	  equ	 3	 ;  䫠,  몠쭮 
b1_choise equ	 4	 ;  롮 ⨯ 饭: ଠ-
b2_cap	  equ	 5	 ;  誠:  - ࠢ
;******************** Ports Bits ***************************************
in_musik  equ	4	; port A - 室	모
muz_prog  equ	2	; port B - 室	४.	musik-programma
;******* RON - ॣ	饣 祭 ******************************
mode1	  equ	20h    ; ०,	ᬮ ᠭ	
polustep  equ	21h    ; 蠣  楤 slowly
rxt	  equ	22h    ;  ᯮ塞  ⥪ 
adr_job	  equ	23h    ; ⥪騩  
speed	  equ	24h    ; ᪮ ઠ (30 =	58hz)
count_s	  equ	25h    ; (+RTCC)ઠo	( ०) ⥪騩 稪
count_z	  equ	26h    ; (+RTCC)ઠo	⥪騩	稪
step_zer  equ	27h    ; ઠo ⥪騩 蠣
stone	  equ	28h    ; 蠣   饭
sqw	  equ	29h    ; ᪢ 	 饭
count_p	  equ	2Ah    ; (+RTCC)প ᫥ ய 모 LB
count_p2  equ	2Bh    ; প ᫥	ய 모 HB
count_m	  equ	2Ch    ; (+RTCC)music প  ᪥ ᨫ쭮  LB
count_m2  equ	2Dh    ; music প	 ᪥ ᨫ쭮 	HB
count_r	  equ	2Eh    ; (+RTCC)প  ࠡ ० "ணࠬa"
count_r2  equ	2Fh    ; প  ࠡ ० "ணࠬa"
count_gd  equ	31h    ; প ᫥	 ࠢ
;temp_1	   equ	 32h	; ६,⮫쪮  祭 楤
count_ch  equ	33h    ; (+RTCC)প  ᫥. 蠣 誨
speed_ch  equ	34h    ; ᪮ 饭 誨
step_cap  equ	35h    ; 蠣 誨
;****************** Constants ******************************************
konst_p	   equ	 d'90'	; ⠭ ᫥ ய 모
konst_r	   equ	 d'55'	; 109=1sec ⠭  ࠡ	ணࠬ
konst_m	   equ	 d'26'	; ⠭ 	᪥ ᨫ쭮 
konst_sqw  equ	 d'16'	; 64 ⠭ ਡ 蠣 猪
;******************* Code Main Program *********************************
	ORG	0	   ;  
	goto	Start	   ; 室 	砫 ணࠬ
;***********************************************************************
speedTable  ; ᮮ⭮襭   ᪮ -  ⮢ 
	    addwf      PC,F	   ; W + PC -> PC
  DT   d'70',d'70',d'60',d'60'	; 90k -	20hz ! 72k- 25hz    20 21 22 23
  DT   d'55',d'55',d'50',d'50'	; 60k -	30hz \ 50k- 36hz    24 25 26 27
  DT   d'47',d'47',d'43',d'43'	; 42k -	43hz \ 35k- 51hz !! 28 29 2a 2b
  DT   d'40',d'40',d'37',d'37'	; 25k -	70hz \ 20k- 80hz !! 2c 2d 2e 2f
;***********************************************************************
stepZer	    addwf      PC,F    ; 室 W- 蠣  0	 3
  dt   b'10100000',b'10010000',b'01010000',b'01100000' ; - A,9,5,6
;***********************************************************************
stepgobo   addwf      PC,F    ;	室 W- 蠣  0  3
  dt   b'1011',b'1111',b'0111',b'0011'
;***********************************************************************
comTable: addwf	PC,F ; 室 W-    127
; Oᠭ  : 0-close, 20h-stop, 21h-.饭
; ᪮:	x22=25Hz,x24=30Hz,x26=36Hz,x28=43Hz,x2A=51Hz - -
;-----------------------------------------------------------------------
;    :   0  31
    dt	0x21,0x3A,0x39,0x3A,0x39,0x3A,0x39,0x2A	;
    dt	0x33,0x2b,0x2a,0x2b,0x2a,0x2b,0x2a,0x2b	;
    dt	0x34,0x22,0x22,0x23,0x23,0x22,0x22,0x23	;
    dt	0x35,0x28,0x20,0x29,0x20,0x28,0x20,0x29	;
;    :   32	 63
    dt	0x36,0x26,0x27,0x26,0x27,0x26,0x27,0x2A	;
    dt	0x37,0x38,0x37,0x38,0x37,0x38,0x37,0x38	;
    dt	0x39,0x22,0x23,0x22,0x23,0x22,0x23,0x22	;
    dt	0x3A,0x28,0x3B,0x29,0x3A,0x28,0x3B,0x29	;
;    :   64	 95
    dt	0x21,0x3A,0x39,0x3A,0x39,0x3A,0x39,0x2A	;
    dt	0x33,0x2b,0x2a,0x2b,0x2a,0x2b,0x2a,0x2b	;
    dt	0x34,0x22,0x22,0x23,0x23,0x22,0x22,0x23	;
    dt	0x35,0x28,0x20,0x29,0x20,0x28,0x20,0x29	;
;    :   96	 127
    dt	0x36,0x26,0x27,0x26,0x27,0x26,0x27,0x2A	;
    dt	0x37,0x38,0x37,0x38,0x37,0x38,0x37,0x38	;
    dt	0x39,0x22,0x23,0x22,0x23,0x22,0x23,0x22	;
    dt	0x3A,0x28,0x3B,0x29,0x3A,0x28,0x3B,0x29	;
;***********************************************************************
Start				    ; Main Programm
	    bsf		Status,RP0  ; c࠭ 1
	    movlw	b'00001101' ; PB0-in 9600   PB1-out 9600
	    movwf	TrisB	    ; PB1-muz\progr PB2-mast\slave
	    movlw	b'00010000' ; PB4,5,6,7	७ ઠ
	    movwf	TrisA	    ; PA3-in,sound    P0,1,2,3-gobo
	    clrwdt		    ;  WDT	⠩
	    movlw	b'00000011' ; XT -> Prescaler(1:16) -> RTCC
	    movwf	OptionR	    ; ⨢ 㧪
	    bcf		Status,RP0  ; c࠭ 0
	    clrf	PortA	    ;
	    clrf	PortB	    ;
	movlw	0x20		    ;
	movwf	Fsr		    ;
clear_mem:			    ;
	clrf	Indf		    ;
	incf	Fsr,f		    ;
	cpi	Fsr,0x4e	    ;
	jnz	clear_mem	    ;
	    mvi		speed_ch,d'40'	  ; k=1800/hz |	k40=45hz
	    mvi		speed,d'45'	  ; k=1800/hz |	k40=45hz
;***********************************************************************
base_cuc:		       ; 砫
	bcf	PortB,1
	btfss	PortA,in_musik ; ஢ઠ  ?
	goto	base_led       ;  
	bsf	PortB,1
base_led:
	call	plusTimer      ; ਡ  稪
	call	zerkalo	       ; 譥 ઠ
	call	cap	       ; ७ 誠
	clrwdt		       ;  WDT ⠩
;--------------- ஢ઠ ४⥫ --------------------------------
	btfss	PortB,muz_prog ; ஢ઠ  ४祭
	goto	mode_music     ; 祭,  .모
;--------------- ० ணࠬ ----------------------------------------
mode_program:
	movlw	0ffh	       ; ࠢ 稪  ⠭⮩
	subwf	count_r,w      ;
	jnc	base_cuc       ; ret,   襫  ஢ ⠭
	incf	count_r2,f     ;
	movlw	konst_r	       ; ࠢ 稪  ⠭⮩
	subwf	count_r2,w     ;
	jnc	base_cuc       ; ret,   襫  ஢ ⠭
	clrf	count_r	       ; 襫,
	clrf	count_r2       ; 㫨 প
	bsf	mode1,b1_stop  ; ⠭ 	
	call	follow_prog    ; ࠡ⪠ ணࠬ
	goto	base_cuc       ; ய ࠡ⪨ 모
;--------------- ० ࠡ⪨ 모	---------------------------------
mode_music:		       ; ᭮ 横
	call	music	       ;   ࠡ⪠ 몠 
	call	posle	       ; 몫 饭 १ 1 ᥪ ᫥
	goto	base_cuc       ;    ।
;***********************************************************************
follow_prog:			; ⥫ ணࠬ 稪 
	incf	adr_job,f	; ᫥ 
	movtow	adr_job
	cpi	adr_job,d'126'	;   ⠡
	jc	foll_obx	; 室 ᫨ arg < const
	mvi	adr_job,0
foll_obx:
	movf	adr_job,0	; 		-> W
	call	comTable	;  -> W
	movtof	rxt		;
;-----------------------------------------------------------------------
analiz:
	cpi	rxt,0	      ;	 = 00h ?
	jz	slave_20      ;		  ⠭ ઠ
	cpi	rxt,0x20      ;	 = 20h ?
	jz	slave_20      ;	⠭ ઠ
      cpi     rxt,0x21	    ;  = 21h ?
      jz      slave_21	    ; 	饭
	cpi	rxt,0x2f      ;
	jc	slave_z	      ;	室	᫨  ઠ: 21< data< 2f
	cpi	rxt,0x3f      ;
	jc	slave_cap     ;	室	᫨  誠:	31< data< 3f
	ret		      ;	    - 室
slave_20:			; ⠭ 饭
	bcf	mode1,b1_wrStop	; 䫠 ⠭  ᫥.
	bcf	mode1,b1_stop	; ⠭ 䫠 ⮯
	ret
slave_21:			;  饭   ஭
	bsf	mode1,b1_wrStop	; 䫠 ⠭ - ० 
	bsf	mode1,b1_choise	; 䫠 롮 slowly ᪮
	bsf	mode1,b1_stop	; ⠭ 䫠 
	ret
slave_z:			 ; ࠧ-᪮ 饭  ࠧ ஭
	bcf	mode1,b1_choise	 ; 䫠	롮 ன ᪮
	bsf	mode1,b1_stop	 ; ⠭ 䫠 
	movtow	rxt	       ; 㥬  -> W
	andlw	0fh	       ; max = 16 祭
	call	speedTable     ; ८ࠧ .   ᪮
	movwf	speed	       ; W -> ⠭ ᪮
	bsf	mode1,b1_wrStop	  ; 䫠 ⠭ - ० 
	btfss	rxt,0		  ; ஢ઠ 	⭮: -ࠢ
	goto	mus_left	  ; 饭 
	bsf	mode1,b1_direct	  ; 饭 ࠢ
	return
mus_left:
	bcf	mode1,b1_direct	  ; 饭 
	return
slave_cap:		       ; 饭 誨 ࠧ	஭
	bsf	mode1,b1_stop  ; ⠭ 䫠 
	movtow	rxt	       ; 㥬  -> W
	andlw	0fh	       ; max = 16 祭
	call	speedTable     ; ८ࠧ .   ᪮
	movwf	speed_ch       ; W -> ⠭ ᪮
	btfss	rxt,0	       ; ஢ઠ  ⭮: -ࠢ
	goto	cas_left       ; 饭 
	bsf	mode1,b2_cap   ; 饭 ࠢ
	return
cas_left:
	bcf	mode1,b2_cap   ; 饭 
	return
;***********************************************************************
plusTimer:		   ; ਡ  稪
	btfss	 Timer,3   ;  ஢ઠ ࠧ鸞 3
	return		   ;   3=0 -> த 横
	clrf	 Timer	   ;   3=1 ->    |  ⠩
	incf	count_z,f  ; ઠ	    | 	ਡ 祭
	incf	count_s,f  ; . ᪮ | 稪	 1
	incf	count_p,f  ; ᫥饭  | 
	incf	count_m,f  ;! . 모   | 稪 뢠
	incf	count_r,f  ;!  ணࠬ  | ᢮  楤ன
	incf	count_ch,f ; ᪮ 誨 |
	return
;***********************************************************************
music:			     ; 	 ࠡ⪠ 몠	
	btfsc	mode1,b1_weit  ; ஢ઠ 䫠	 
	goto	mus_gate     ; 䫠 祭=1, 	
	movlw	0ffh	     ; 䫠 몫祭,
	subwf	count_m,w    ; ࠢ	稪	 ⠭⮩
	jnc	mus_ret	     ; 室,   襫  ஢ ⠭
	incf	count_m2,f
	movlw	konst_m	     ; ࠢ	稪	 ⠭⮩
	subwf	count_m2,w   ;
	jnc	mus_ret	     ; 室,   襫  ஢ ⠭
	clrf	count_m	     ; 襫,
	clrf	count_m2     ; 㫨	প 
	bsf	mode1,b1_weit  ; ⠭ 䫠 (=1)  
mus_ret:
	ret
;-----------------------------------------------------------------------
mus_gate:
	btfss	PortA,in_musik	; ஢ઠ 	?
	goto	mus_ret		;  
	bcf	mode1,b1_weit	  ; .䫠 -  	室
	goto	follow_prog	; ⥫ ணࠬ 稪 
;***********************************************************************
cap:			      ;	७ 誠
	btfss	mode1,b1_stop ;	஢ઠ ०	(0)	0-⮯,1-
	return		      ;	᫨ 0 - 誠 ⮨
	movf	speed_ch,w    ;	஢  co
	subwf	count_ch,w    ;	⥪饣 祭 稪
	btfss	Status,CR     ;	 ⠭	᪮
	return		      ;	᫨ ᮢ,	  ய
	clrf	count_ch      ;	 稪 饭 ઠ
	btfss	mode1,b2_cap  ;	஢ઠ ०	 0-,1-ࠢ
	goto	cap_left      ;	᫨ 0    ய
	incf	step_cap,f    ;	ࠢ - 蠣 
	goto	cap_job	      ;	஢稢   1 蠣
cap_left:
	decf	step_cap,f    ;	 -	蠣 
cap_job:
	movlw	b'00000011'   ;	㧨 	蠣 - ᥣ 4!	蠣
	andwf	step_cap,w    ;	㤠	 ९   ॣ W
	call	stepgobo      ;	८ࠧ  蠣   
	movwf	PortA	      ;	뤠  蠣  
	return
;***********************************************************************
zerkalo:		      ;	㦭 ઠ
	btfss	mode1,b1_stop ;	஢ઠ ०	(0)	0-⮯,1-
	return		      ;	᫨ 0 - ⮨
	btfss	mode1,b1_wrStop	; 䫠 ६ ⠭
	return		      ;		᫥. 
	btfsc	mode1,b1_choise	; 䫠 롮 ० ᪮
	goto	slowly	      ;	1= 饭 ઠ
;***********************************************************************
mot_zer:		      ;	ଠ쭮 饭 
	movf	speed,w	      ;	஢  co
	subwf	count_z,w     ;	⥪饣 祭 稪
	btfss	Status,CR     ;	 ⠭	᪮
	return		      ;	᫨ ᮢ,	  ய
	clrf	count_z	      ;	 稪 饭 ઠ
	btfss	mode1,b1_direct	; ஢ઠ ०  0-,1-ࠢ
	goto	mot_left      ;	᫨ 0    ய
mot_right:
	incf	step_zer,f    ;	ࠢ - 蠣 
	goto	mot_job	      ;	஢稢   1 蠣
mot_left:
	decf	step_zer,f    ;	 -	蠣 
mot_job:		      ;	஢稢   1 蠣
	movlw	b'00000011'   ;	㧨 	蠣 - ᥣ 4!	蠣
	andwf	step_zer,w    ;	㤠	 ९   ॣ W
	call	stepZer	      ;	८ࠧ  蠣   
	movwf	PortB	      ;	뤠  蠣  
	btfss	PortA,in_musik	; ஢ઠ 	?
	return			;  
	bsf    PortB,1
	return
;***********************************************************************
posle:				; 몫 饭	१ 2	ᥪ ᫥
	btfss	PortA,in_musik	; ய 㪮 ᮢ
	goto	posl_nogate	; ஢ઠ 		?
	bsf	mode1,b1_stop	; ,	⠭ ० 
	clrf	count_p		; 㫨 稪 訩
	clrf	count_p2	; 㫨 稪 訩
	ret
posl_nogate:		       ;  
	movlw	0ffh	       ; ࠢ 稪  ⠭⮩
	subwf	count_p,w      ;
	jnc	posl_ret       ; ret,   襫  ஢ ⠭
	incf	count_p2,f     ;
	movlw	konst_p	       ; ࠢ 稪  ⠭⮩
	subwf	count_p2,w     ;
	jnc	posl_ret       ; ret,   襫  ஢ ⠭
	clrf	count_p2       ; 㫨 稪 訩
	bcf	mode1,b1_stop  ; 襫,	⠭ ० 
	clrf	   PortA       ;
	clrf	   PortB       ;
posl_ret:
	ret
;***********************************************************************
slowly:
	movlw	d'02'	   ; ஢  co
	subwf	count_s,w  ; ⥪饣 祭 稪
	btfss	Status,CR  ;  ⠭ ᪮
	goto	cross_v	   ; ᫨ ᮢ,   ய
	clrf	count_s	   ;  稪 ⠩
	decf	polustep,f ; 㬥 稪 ᪢
	jz	newl	   ; ᫨  = 0  ⨯
	decf	polustep,f ; 㬥 稪 ᪢
	jz	newl	   ; ᫨  = 0  ⨯
	goto	cross_v	   ; ४⥫
newl:
	incf	stone,f	   ;  塞 ⨯
	movlw	b'00000011';  ४⥫
	andwf	stone,f	   ;  譨 
cross_v:
	movlw	1	   ; ࠢ ॣ 	⠭⮩
	subwf	stone,w	   ;  室  㣮 蠣
	jz	var2
	movlw	2	   ; ࠢ ॣ 	⠭⮩
	subwf	stone,w	   ;  室  㣮 蠣
	jz	var3
	movlw	3	   ; ࠢ ॣ 	⠭⮩
	subwf	stone,w	   ;  室  㣮 蠣
	jz	var4
;-----------------------------------------------------------------------
var1:
	movlw	konst_sqw     ;	롮 뢮 ᪢
	addwf	sqw,f	      ;	   ⮪ 
	cmp	sqw,polustep  ;	᫨  - 1->0
	jc	ust1_1	      ;	᫨  - 0->1
     movf  PortB,w	;   B -> W
     andlw 0fh		; 㫨 ஥ 祭 蠣	 W
     iorlw b'10100000'	;   㣮  	wrem1->W
     movwf PortB	; 뤠  蠣  
     return
ust1_1:
     movf  PortB,w	;   B -> W
     andlw 0fh		; 㫨 ஥ 祭 蠣	 W
     iorlw b'10010000'	;   㣮  	wrem1->W
     movwf PortB	; 뤠  蠣  
     return
;-----------------------------------------------------------------------
var2:
	movlw	konst_sqw     ;	롮 뢮 ᪢
	addwf	sqw,f	      ;	   ⮪ 
	cmp	sqw,polustep  ;	᫨  - 1->0
	jc	ust2_1	      ;	᫨  - 0->1
     movf  PortB,w	;   B -> W
     andlw 0fh		; 㫨 ஥ 祭 蠣	 W
     iorlw b'10010000'	;   㣮  	wrem1->W
     movwf PortB	; 뤠  蠣  
     return
ust2_1:
     movf  PortB,w	;   B -> W
     andlw 0fh		; 㫨 ஥ 祭 蠣	 W
     iorlw b'01010000'	;   㣮  	wrem1->W
     movwf PortB	; 뤠  蠣  
     return
;-----------------------------------------------------------------------
var3:
	movlw	konst_sqw     ;	롮 뢮 ᪢
	addwf	sqw,f	      ;	   ⮪ 
	cmp	sqw,polustep  ;	᫨  - 1->0
	jc	ust3_1	      ;	᫨  - 0->1
     movf  PortB,w	;   B -> W
     andlw 0fh		; 㫨 ஥ 祭 蠣	 W
     iorlw b'01010000'	;   㣮  	wrem1->W
     movwf PortB	; 뤠  蠣  
     return
ust3_1:
     movf  PortB,w	;   B -> W
     andlw 0fh		; 㫨 ஥ 祭 蠣	 W
     iorlw b'01100000'	;   㣮  	wrem1->W
     movwf PortB	; 뤠  蠣  
     return
;-----------------------------------------------------------------------
var4:
	movlw	konst_sqw     ;	롮 뢮 ᪢
	addwf	sqw,f	      ;	   ⮪ 
	cmp	sqw,polustep  ;	᫨  - 1->0
	jc	ust4_1	      ;	᫨  - 0->1
     movf  PortB,w	;   B -> W
     andlw 0fh		; 㫨 ஥ 祭 蠣	 W
     iorlw b'01100000'	;   㣮  	wrem1->W
     movwf PortB	; 뤠  蠣  
     return
ust4_1:
     movf  PortB,w	;   B -> W
     andlw 0fh		; 㫨 ஥ 祭 蠣	 W
     iorlw b'10100000'	;   㣮  	wrem1->W
     movwf PortB	; 뤠  蠣  
     return
;**************************************************************
;     " BrSoft Copyright (C) 2001 Bogdanov Andrew "
;***********************************************************************

	   End

